﻿Module Module1

    Delegate Function FixedPointFunction(Of TIn, TOut) _
        (ByVal f As Func(Of TIn, TOut)) As Func(Of TIn, TOut)

    Function Fix(Of T, TRes)(ByVal f As FixedPointFunction(Of T, TRes)) _
            As Func(Of T, TRes)

        Return f(Function(x) Fix(f)(x))
    End Function

    Sub Main()
        Dim Factorial = Fix(Of Integer, Integer) _
            (Function(f) Function(x) If(x <= 1, 1, x * f(x - 1)))

        Dim k = 7
        Console.WriteLine("{0}! = {1}", k, Factorial(k))

        Console.ReadKey()
    End Sub

End Module
